package gq.unurled.raxen.components.dungeons;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.dungeons.types.MonsterType;
import gq.unurled.raxen.components.dungeons.types.forest.ForestMonster;
import gq.unurled.raxen.components.entity.other.RaxenEntity;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

import static gq.unurled.raxen.utils.DungeonUtils.getRadiusFromRank;
import static gq.unurled.raxen.utils.Utils.log;

public class Dungeon {

    private String name;

    private Rank rank;

    private Gate gate;

    private Map<String, RaxenEntity> monster = new HashMap();

    /**
     * The Type of the Dungeon
     */
    private Types types;

    /**
     * Monster Types
     */
    private MonsterType monsterType;

    private Location location;
    private Integer radius;

    public Dungeon(String name, Rank rank, Types types, MonsterType mType) {
        this.name = name;
        this.rank = rank;
        this.types = types;
        this.monsterType = mType;
    }

    /**
     * Generate the Gate and make it available to players in the world.
     * TODO: Place the gate at a random place.
     */
    public void generateGate() {
        // -281.50 36.00 187.50
        Location loc = new Location(Bukkit.getWorld("Liberty_City"), -284.0, 45.00, 187.50);
        Integer radius = getRadiusFromRank(this.rank);
        this.gate = new Gate(name, loc, radius);
    }

    /**
     * TODO: Terrain Generation of the inside of the Dungeons
     */
    public void generate() {
        Raxen main = (Raxen) Bukkit.getPluginManager().getPlugin("Raxen");
        main.getManager().getWorldManager().loadWorld(name);
        monsterType.genMonster(Bukkit.getWorld(name), rank);

    }
}
