package gq.unurled.raxen.components.dungeons.types.forest;

import gq.unurled.raxen.components.dungeons.Rank;
import gq.unurled.raxen.components.dungeons.types.MonsterType;
import gq.unurled.raxen.components.entity.other.custom.dungeon.forest.Elf;
import gq.unurled.raxen.components.entity.other.custom.dungeon.forest.Wolf;
import lombok.Getter;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Zombie;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitScheduler;
import org.bukkit.scheduler.BukkitTask;
import org.jetbrains.annotations.NotNull;

import java.util.Random;

import static gq.unurled.raxen.utils.Utils.debug;
import static org.apache.commons.lang.math.RandomUtils.nextInt;

public class ForestMonster implements MonsterType {
    @Override
    public void genMonster(World world, Rank rank) {
        Double x = 0.0;
        Double y = 100.0;
        Double z = 0.0;
        for (type type : type.values()) {
            type.name();
            Random r = new Random();
            int per = r.nextInt(100);
            if (per >= type.rate) {
                // spawn entity
                debug("Spawning Entity " + type.ID);
                Entity e = world.spawnEntity(new Location(world, x, y, z), EntityType.ARROW);
                e.setInvulnerable(true);
                BukkitTask task = new BukkitRunnable() {
                    @Override
                    public void run() {
                        Location loc = new Location(e.getWorld(), e.getLocation().getX(), e.getLocation().getY()-1, e.getLocation().getZ());
                        if (loc.getBlock().getType() != Material.AIR) {
                            e.setInvulnerable(false);
                            this.cancel();
                        }
                    }
                }.runTaskTimerAsynchronously(Bukkit.getPluginManager().getPlugin("Raxen"), 0L, 20L);
            }
            x = 5.0 + ( 50.0 - 5.0 ) * r.nextDouble();
            z = 5.0 + ( 50.0 - 5.0 ) * r.nextDouble();
        }
    }

    @Getter
    enum type {
        ELF(50.0 ,"ELF", Elf.class),
        WOLF(50.0, "WOLF", Wolf.class);

        private Double rate;
        public String ID;
        public Class clazz;

        type(Double rate, String ID, Class clazz) {
            this.rate = rate;
            this.ID = ID;
            this.clazz = clazz;
        }
    }
}
